% Figure 2: Conservativeness of the KP-M test. The number of Monte Carlo
% simulations is 10,000, ...
% In "Inference on the Rank of a Matrix" by Qihui Chen and Zheng Fang (2019).
% Edited by Qihui Chen and Zheng Fang (2019)
% Updated on 5/1/2019
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% X_{i} = W_{i}*Pi_{0} + u_{i}
% X_{i} is 1*k, W_{i} is 1*m and U_{i} is 1*k
% Pi is m*k, m>=k
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Testing H_{0}: Rank(Pi_{0})<=r v.s. H_{1}: Rank(Pi_{0})>r
% To show the mutiple KP test is not powerful.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
n = 1000;
r = 5;
%%%%%%%%%%%%%%%%%%%%(Change this to obtain different curves)%%%%%%%%%%%%%%%%%%%%%%%
d = 1; % 1,2,3,4,5,6;
rept = 10000; % 10000 Monte Carlo replications
delta = 0:0.02:0.2;
rej = zeros(rept,1); % indicator for rejection
asysize = zeros(length(delta),1);
for j=1:length(delta)  
    for i = 1:rept
         i
        rng(i^2+5)
    %% DGPs
        m = 6; 
        k = 6;
        Pi = diag([ones(k-d,1);zeros(d,1)])+delta(j)*eye(k);
        u = randn(n,k); % normal error terms
        % u = sqrt(2)*trnd(4,n,k); % fat tail error terms
        W = randn(n,m);
        % Sigma = kron(ones(1,k),W(:,1)); % heteroskedasticity
        X = W*Pi + u;
    %% Kleibergen and Paap (2006)'s Method
       RankKP = zeros(r+1,1);
       CV = zeros(r+1,1);
       for q=1:r+1
           [RankKP(q)] = TestingRankKP(W,X,q-1);
           CV(q) = icdf('chi2',0.95,(m-q+1)*(k-q+1));
       end
       rej(i) = prod(RankKP>CV);
    end
    asysize(j) = mean(rej);
end
save result1.mat asysize

    