% Figure 4/5: The rank estiamtion: rank(\Pi_0) = 6, alpha = 5% and delta = 0.1 (delta = 0.12)
% In "Inference on the Rank of a Matrix" by Qihui Chen and Zheng Fang (2019).
% Edited by Qihui Chen and Zheng Fang (2019)
% Updated on 5/1/2019
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% X_{i} = W_{i}*Pi_{0} + u_{i}
% X_{i} is 1*k, W_{i} is 1*m and U_{i} is 1*k
% Pi is m*k, m>=k
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
% Rank determination
% To show our test improves the accuracy
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
n = 1000;
%%%%%%%%%%%%%%%%%%%%(Change this to obtain different results)%%%%%%%%%%%%%%%%%%%%%%%
d = 1; % 1,2,3,4,5,6;
%%%%%%%%%%%%%%%%%%%%(Change this to obtain different results)%%%%%%%%%%%%%%%%%%%%%%%
delta = 0.1; % 0.12
rept = 5000; %5000 Monte Carlo replications
RankEst = zeros(rept,2); % Compare two methods
B = 500; %500 bootstrap replications
%%%%%%%%%%%%%%%%%%%%(Change this to obtain different results)%%%%%%%%%%%%%%%%%%%%%%%
kappan = n^(-1/4); % n^{-1/4}; n^{-1/3}; n^{-2/5}; Tuning parameter
WLL = zeros(B,1);
for j=1:length(delta)
    for i = 1:rept
        i
        rng(i^2+5)
    %% DGPs
        m = 6; 
        k = 6;
        Pi = diag([ones(k-d,1);zeros(d,1)])+delta(j)*eye(k);
        u = randn(n,k); % normal error terms
%         u = sqrt(2)*trnd(4,n,k); % fat tail error terms
        W = randn(n,m);
%         Sigma = kron(ones(1,k),W(:,1)); % heteroskedasticity
        X = W*Pi + u;

    %% Rank Determination
       RankEst(i,:) = k*ones(1,2);
       % Kleibergen and Paap (2006)'s Test
       for q=1:k
           [RankKP] = TestingRankKP(W,X,q-1);
           CV = icdf('chi2',0.95,(m-q+1)*(k-q+1));
           if RankKP<CV
              RankEst(i,1) = q-1;
              break;
           end
       end
       % Our Test
       Pi_hat =W'*X/n; % (pinv(W'*W)*W'*X); m*k
       for q=1:k
           tempt = sort(svd(Pi_hat).^2);
           [lambdasum_hat] = sum(tempt(1:k-q+1)); % compute the test statistic for real data
            for b = 1:B
                rng(i^2+5+6*q+10*b)
                ind = unidrnd(n*ones(n,1));
                Wb = W(ind,:);
                Xb = X(ind,:);
                [WLL(b)] = TestingRankBootStruct(Wb,Xb,Pi_hat,kappan,q-1); % Chen and Fang (2019)'s Structural method
            end
           if n*lambdasum_hat<quantile(WLL,0.95)
              RankEst(i,2) = q-1;
              break;
           end
       end
       
    end
end
Percent = hist(RankEst,0.5:1:5.5)/rept;
save result1.mat RankEst Percent

    