% Table 1: Estimation of rank(Pi_0) Defined by the Model (6)-(7)
% In "Inference on the Rank of a Matrix" by Qihui Chen and Zheng Fang (2019).
% Edited by Qihui Chen and Zheng Fang (2019)
% Updated on 5/1/2019
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% X_{i} = W_{i}*Pi_{0} + u_{i}
% X_{i} is 1*k, W_{i} is 1*m and U_{i} is 1*k
% Pi is m*k, m>=k
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
% Testing H_{0}: Rank(Pi_{0})<=r v.s. H_{1}: Rank(Pi_{0})>r
% To show CF-A is sensitive to tuining parameters and motivation for two-step procedure
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
n = 1000;
r = 5;
alphaa = 0.05;
%%%%%%%%%%%%%%%%%%%%(Change this to obtain different curves)%%%%%%%%%%%%%%%%%%%%%%%
d = 1; % 1,2,3,4,5,6;
%%%%%%%%%%%%%%%%%%%%(Change this to obtain different curves)%%%%%%%%%%%%%%%%%%%%%%%
kappan = n^(-1/5); % n^{-1/4}; n^{-1/3}; n^{-2/5}; Tuning parameter
betaa = alphaa/5; % Tuning parameter
delta = 0;
rept = 10000; %10000 Monte Carlo replications
B = 500; %500 bootstrap replications
r0 = 6-d;
rzero1 = zeros(rept,1);
rzero2 = zeros(rept,1);
parfor i = 1:rept
    i
    rng(i^2+5)
   %% DGPs
    m = 6; 
    k = 6;
    Pi = diag([ones(k-d,1);zeros(d,1)])+delta*eye(k);
    u = randn(n,k); % normal error terms
    % u = sqrt(2)*trnd(4,n,k); %fat tail error terms
    W = randn(n,m);
    % Sigma = kron(ones(1,k),W(:,1)); % heteroskedasticity
    X = W*Pi + u;

%% Matrix Esetimator
    Pi_hat =W'*X/n; % (pinv(W'*W)*W'*X); m*k
    S = svd(Pi_hat); 
    rzero1(i,1) = sum(S>kappan);

%% Chen and Fang (2019)'s Bootstrap (two step procedure)        
    RankKP = zeros(r+1,1);
    PV = zeros(r+2,1);
    PV(r+2) = 1;
    for q=1:r+1
        [RankKP(q)] = TestingRankKP(W,X,q-1);
        PV(q) = 1-cdf('chi2',RankKP(q),(m-q+1)*(k-q+1));
    end
    rzero2(i,1) = find(PV>betaa, 1)-1;                   
end
rzero3 = min(rzero1,r);
rzero = [rzero1,rzero2,rzero3];
freq1 = mean(rzero == r0);
save result1.mat freq1

    